#include <bits/stdc++.h>

using namespace std;

#define int long long

struct merge_tree{
    vector < vector <int> > t;

    void build(int v, int tl, int tr, vector <int> &h){
        if(tl + 1 == tr){
            t[v].push_back(h[tl]);
            return;
        }

        int tm = (tl + tr) / 2;
        build(v * 2, tl, tm, h);
        build(v * 2 + 1, tm, tr, h);
        t[v].resize(t[v * 2].size() + t[v * 2 + 1].size());
        merge(t[v * 2].begin(), t[v * 2].end(), t[v * 2 + 1].begin(), t[v * 2 + 1].end(), t[v].begin());
    }

    int quer(int v, int l, int r, int tl, int tr, int x){
        if(tl >= r || tr <= l){
            return 0;
        }
        if(tl >= l && tr <= r){
            return lower_bound(t[v].begin(), t[v].end(), x) - t[v].begin();
        }

        int tm = (tl + tr) / 2;
        return quer(v * 2, l, r, tl, tm, x) + quer(v * 2 + 1, l, r, tm, tr, x);
    }
};

struct quer{
    int t, x, l, r;
};

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int q;
    cin >> q;
    vector <quer> a;
    vector <int> b;
    int n = 0;
    for(int i = 0; i < q; ++i){
        int t, x, l = 0, r = 0;
        cin >> t;
        if(t == 1){
            cin >> x;
            b.push_back(x);
            ++n;
        }else{
            cin >> l >> r >> x;
            --l;
            --r;
        }

        a.push_back({t, x, l, r});
    }

    merge_tree t;
    t.t.resize(4 * n);
    t.build(1, 0, n, b);

    for(auto i : a){
        if(i.t == 2){
            cout << t.quer(1, i.l, i.r + 1, 0, n, i.x + 1) << '\n';
        }
    }
}